// синтезатор частоти на 3 діапазони для трансивера з одним перетворенням частоти UR4UPQ 20.11.21
#include <Wire.h>
#include <SimpleRotary.h>
#include "si5351.h"
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27,16,2); //налаштування дисплея
#define buttonssb  2 //пін кнопки перемикання бокової полоси
#define buttonTx   4 //пін кнопки передача
#define buttonstep 5 //пін кнопки на енкодері який перемикає крок налаштування частоти
#define buttonBAND  8 //пін кнопки перемикання діапазонів
#define BAND1  9 //пін на якому в режимі ДІАПАЗОН 1 буде сформовано +5 вольт
#define BAND2  10 //пін на якому в режимі ДІАПАЗОН 2 буде сформовано +5 вольт
#define BAND3  11  //пін на якому в режимі ДІАПАЗОН 3 буде сформовано +5 вольт
#define Tx   13 //пін на якому в режимі передача буде сформовано +5 вольт
#define PIN_SM     A0 // вхід типу с-метра



SimpleRotary rotary(7,6,5); // піни енкодера (ліво,право,кнопка)
Si5351 si5351;

volatile uint32_t usb = 800000000;// частота ПЧ + два ноля в конце(так нужно для si5351)
volatile uint32_t vfo = 360000000+usb; // частота ГПД + два ноля в конце(так нужно для si5351)

long radix = 10000;
int step_1 = 0;
int var = 0;
int varold = 1;
long bfo = 0;
byte ones,tens,hundreds,thousands,tenthousands,hundredthousands,millions ;  //розбивання частоти для відображення крапок
int var3 = 0;
int var4 = 0;
int varold4 = 1;
int var5 = 0;
int varold5 = 1;
int usb1 = 0;
uint16_t val_sm = 0;
uint16_t val_sm_old = 1;
unsigned long period_time = (long)1*1000;
unsigned long my_timer;

//квадратики для с-метра
byte pBar[8] = {
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
  B11111,
};
byte pBar1[8] = {
  B11111,
  B10001,
  B10001,
  B10001,
  B10001,
  B10001,
  B11111,
};
byte pBar2[8] = {
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B11111,
};


void setup() {
  Serial.begin(9600);
  lcd.init();
  lcd.backlight();
  lcd.createChar(0, pBar);
  lcd.createChar(1, pBar1);
  lcd.createChar(2, pBar2);
  analogReference(INTERNAL);
  my_timer = millis();
  bool i2c_found;
  i2c_found = si5351.init(SI5351_CRYSTAL_LOAD_8PF, 0, 65000);
  si5351.set_freq(usb, SI5351_CLK0);
  SetFrequency(vfo);
  si5351.update_status();
  pinMode (Tx, OUTPUT);
  pinMode (BAND1, OUTPUT);
  pinMode (BAND2, OUTPUT);
  pinMode (BAND3, OUTPUT);
  digitalWrite (buttonssb, HIGH);
  digitalWrite (buttonTx, HIGH);
  digitalWrite (buttonBAND, HIGH);
  digitalWrite (buttonstep, HIGH);
  digitalWrite (Tx, LOW);
  digitalWrite (BAND1, HIGH);
  digitalWrite (BAND2, LOW);
  digitalWrite (BAND3, LOW);
  lcd.setCursor(10,0);
       lcd.print("L");
   display_frequency();
   step_radix();
   delay(500);
}


void SetFrequency(double frequency) {  
 si5351.set_freq(vfo, SI5351_CLK1);
    si5351.set_freq(usb, SI5351_CLK0);
}

//-----------------------------------------------відображення частоти 
void display_frequency()
  {
    if (usb1 == 0){
bfo = (vfo/100)-(usb/100);
Serial.print (usb1);
    }
    if (usb1 == 1){
bfo = (vfo/100)+(usb/100);
Serial.print (usb1);
    }
    millions = int(bfo/1000000);
    hundredthousands = ((bfo/100000)%10);
    tenthousands = ((bfo/10000)%10);
    thousands = ((bfo/1000)%10);
    hundreds = ((bfo/100)%10);
    tens = ((bfo/10)%10);
    ones = ((bfo/1)%10);
    lcd.setCursor(0,0);
    lcd.print("       ");
   if (millions > 9){lcd.setCursor(0,0);}
   else{lcd.setCursor(0,0);}
    lcd.print(millions);
    lcd.print(".");
    lcd.print(hundredthousands);
    lcd.print(tenthousands);
    lcd.print(thousands);
    lcd.print(".");
    lcd.print(hundreds);
    lcd.print(tens);
    lcd.print(ones);
   
  }

  //--------------------------------------------------відображення кроку налаштування

void step_radix()
{
step_1 = radix/100;
lcd.setCursor(12,0);
lcd.print("s");
if (step_1 == 500)
{lcd.setCursor(13,0);
  lcd.print("500 ");
}
if (step_1 == 100)
{lcd.setCursor(13,0);
  lcd.print("100 ");
}
if (step_1 == 1000)
{lcd.setCursor(13,0);
  lcd.print("1K ");
}

}

void show_sm() {

  uint8_t a = 0;
  uint8_t m = 0;

  a = (val_sm + 3) / 51;            // налаштування для с-метра, потрібно підбирати
  lcd.setCursor(0,1);
  for (m = 0; m < a; m++)
    if (m < 10)
      lcd.write(byte(0));               // '5' - hollow rectangle, 6px
    
    else
      lcd.write(byte(1));               // '6' - filled rectangle, 6px
  
  for (m = a; m < 20; m++)
   lcd.write(byte(2));                 // '_' 1px
}



//----------------------------------------------------
void loop() {
    byte i;
i = rotary.rotate();

  if ( i == 1 ) {
    my_timer = millis();
     vfo=vfo + radix;
    si5351.set_freq(vfo, SI5351_CLK1);
    display_frequency();
  }

  if ( i == 2 ) {
    my_timer = millis();
    vfo=vfo - radix;
    si5351.set_freq(vfo, SI5351_CLK1);
    display_frequency();                      
  }
  if ((long)millis() - my_timer > period_time) {
       val_sm = analogRead(PIN_SM);
  if ((abs(val_sm - val_sm_old)) > 3) {  // if needed draw S-meter   
  show_sm();
   val_sm_old = val_sm;
  }
  }
 

//----------------------------------------------крок налаштування частоти
 if (digitalRead (buttonstep) == LOW)
  {
    
    var=varold+1;
      varold=var;
      if (var > 3){
       var = 1;
       varold = 1;
        delay(150);}
    }

   switch(var){
     
     case 1:
      radix=10000;
      step_radix();
      delay(500);   
      var=0;
    break;
    case 2:
      radix=50000;
     step_radix();
      delay(500);     
      var=0;
      break;
    case 3:
      radix=100000;
      step_radix();
      delay(500);  
      var=0;
      break;  
  }


//  --------------------------------------------------режим передача
  if (digitalRead (buttonTx) == LOW)
  {
    //si5351.set_freq(vfo, SI5351_CLK1);
    //si5351.set_freq(usb, SI5351_CLK0);
    digitalWrite (Tx, HIGH);
    var3 = 1;
  }
  if (digitalRead (buttonTx) == HIGH & var3 == 1) 
    {
    digitalWrite (Tx, LOW);
    //si5351.set_freq(vfo, SI5351_CLK1);
   // si5351.set_freq(usb, SI5351_CLK0);
    var3 = 0; 
  }
    
    

     //-------------------------------------------------перемикання бокової полоси для  80 та 40 метрів
   if (digitalRead (buttonssb) == LOW & usb1 == 0)
  {
    
    varold4=var4+1;
    if(varold4==3)
      { 
        varold4=1;
       }
   
    }


   if (varold4==2)
     {
      usb = 8003000; // Значення ПЧ для Вашого фільтра в режимі USB
     si5351.set_freq(usb, SI5351_CLK0);
         lcd.setCursor(10,0);
       lcd.print("U");
      delay(500); 
      varold4=0;
      var4=2;  
     }
     
    if (varold4==1)
    {
      usb = 800000000; // Значення ПЧ для Вашого фільтра в режимі LSB
      si5351.set_freq(usb, SI5351_CLK0);
        lcd.setCursor(10,0);
       lcd.print("L");
      delay(500);
      varold4=0;
      var4=1;   
    }
    //----------------------------------------------перемикання діапазонів
if (digitalRead (buttonBAND) == LOW)
  {
    
    var5=varold5+1;
      varold5=var5;
      if (var5 > 3){
       var5 = 1;
       varold5 = 1;
        delay(150);}
    }

   switch(var5){
     
     case 1:
     usb1 = 0;
      vfo = 360000000+usb;
    si5351.set_freq(vfo, SI5351_CLK1);
      si5351.set_freq(usb, SI5351_CLK0);
       lcd.setCursor(10,0);
       lcd.print("L");
    display_frequency();
    digitalWrite (BAND1, HIGH);
  digitalWrite (BAND2, LOW);
  digitalWrite (BAND3, LOW);
      delay(500);   
      var5=0;
    break;
    case 2:
    usb1 = 0;
       vfo = 710000000+usb;
    si5351.set_freq(vfo, SI5351_CLK1);
    si5351.set_freq(usb, SI5351_CLK0);
       lcd.setCursor(10,0);
       lcd.print("L");
    display_frequency();
    digitalWrite (BAND1, LOW);
  digitalWrite (BAND2, HIGH);
  digitalWrite (BAND3, LOW);
      delay(500);     
      var5=0;
      break;
    case 3:
    usb1 = 1;
      vfo = 1410000000-usb;
    si5351.set_freq(vfo, SI5351_CLK1);
     si5351.set_freq(usb, SI5351_CLK0);
     var4=2;
       lcd.setCursor(10,0);
       lcd.print("U");
        display_frequency();
    digitalWrite (BAND1, LOW);
    digitalWrite (BAND2, LOW);
    digitalWrite (BAND3, HIGH);
      delay(500);     
      var5=0;
      break;  
  }
  }
